#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ShellItemCFG.h"
std::auto_ptr<Fish_ShellItemCFG> Fish_ShellItemCFG::msSingleton(nullptr);

int Fish_ShellItemCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ShellItemCFGData* Fish_ShellItemCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ShellItemCFGData>& Fish_ShellItemCFG::GetMapData()
{
	return mMapData;
}

void Fish_ShellItemCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ShellItemCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ShellItemCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mRate = element->IntAttribute("Rate");
		data.mSound = element->Attribute("Sound");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ShellItemCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ShellItemCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ShellItemCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ShellItemCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ShellItemCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "Rate", data.mRate);
		LuaCfgHelper::readString(L, "Sound", data.mSound);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ShellItemCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ShellItemCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ShellItemCFG* Fish_ShellItemCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ShellItemCFG());
	}
	return msSingleton.get();
}

void Fish_ShellItemCFG::Release()
{
	msSingleton.reset(nullptr);
}
